from statelogic import *
from world import *
import random

class GameEntity(object):
    def __init__(self, world, name, image, initial_position):

        self.world = world
        self.name = name
        self.image = image
        self.location = initial_position
        self.destination = (0,0)
        self.speed = 0.

        self.brain = StateMachine()
        self.id = 0

    def render(self, surface):
        x,y = self.location
        w, h = self.image.get_size()
        surface.blit(self.image, (x-w/2, y-h/2))

    def process(self, time_passed):
        self.brain.think()

        if self.speed > 0 and self.location != self.destination:
            vec_to_destination = Vector.vector_from_points(self.location, self.destination)
            distance_to_destination = vec_to_destination.get_magnitude()
            heading = vec_to_destination.normalize()

            travel_distance = min(distance_to_destination, time_passed* self.speed)
            self.location = (self.location [0] + travel_distance * heading.x, self.location[1] + travel_distance * heading.y)


class Leaf(GameEntity):
    def __init__(self, world, image, initial_position):
        GameEntity.__init__(self, world, "leaf", image, initial_position)
